#include <stdio.h>
#include <unistd.h>

#define MAX_MEM 30000

int  i, p, r, q;
unsigned char a[MAX_MEM], f[MAX_MEM];
char b, o, h, * s = f;
unsigned char * ptr = a;

void abbild(void) {
	for (i=0; i<16; i++) {
		if (i==p) { // Wenn die gerade aktuelle Speicherzelle ausgegeben wird
			fprintf(stderr, "\033[1;29m(\033[0m"); // hebe sie hervor
		} else {
			fprintf(stderr, "(");
		}
		if ((h = *(ptr + i)) == 0){ // wenn die Speicherzelle nur 0 enthlt,
			fprintf(stderr, "\033[1;30m%03u\033[0m", h); // mache sie unaufflliger
		} else {
			fprintf(stderr, "%03u", h);
		}
		if (i==p) { // Wenn die gerade aktuelle Speicherzelle ausgegeben wurde
			fprintf(stderr, "\033[1;29m)\033[0m"); // beende die Hervorhebung
		} else {
			fprintf(stderr, ")");
		}
	}
	fprintf(stderr, "\n");
	usleep(750000); // Mach die Augabe leichter verfolgbar
}

void interpret(char *c) {
	char *d; int tmp;

	r++;
	while( *c ) {
		switch(o=1,*c++) {
			case '#': abbild();   break; // erleichtert das Debugen
			case '<': p--;        break;
			case '>': p++;        break;
			case '+': a[p]++;     break;
			case '-': a[p]--;     break;
			case '.': putchar(a[p]); fflush(stdout); break;
			case ',': {
				tmp=getchar(); 
				if (tmp == EOF) {
					a[p]=0; 
				} else {
					a[p]=tmp;
				} 
				break;
			}
			case '[': {
				for( b=1,d=c; b && *c; c++ ) {
					b+=*c=='[', b-=*c==']';
				}
				if(!b) { 
					c[-1]=0;
					while( a[p] ) {
						interpret(d);
					}
					c[-1]=']';
					break; 
				}
			}
			case ']': puts("UNBALANCED BRACKETS"), exit(0);
			default: o=0;
		}
		if( p<0 || p>MAX_MEM) { // das Speicherband ist beschrnkt
			puts("RANGE ERROR"), exit(0);
		}
	}
	r--;
}

int main(int argc,char *argv[]) {
FILE *infile;

	q=argc;
	if((infile=fopen(argv[1],"r"))) {
		while( (b=getc(infile))>0 ) {
			*s++=b;
		}
		*s=0;
		interpret(f);
	} else {
		puts("CAN'T OPEN INPUTFILE");
		exit(1);
	}
	return 0;
}

